﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using MovieAPI.DbContexts;

#nullable disable

namespace MovieAPI.Migrations
{
    [DbContext(typeof(MovieAPIDbContext))]
    [Migration("20220930090554_initial10")]
    partial class initial10
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.9")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder, 1L, 1);

            modelBuilder.Entity("CharacterMovie", b =>
                {
                    b.Property<int>("CharactersId")
                        .HasColumnType("int");

                    b.Property<int>("MoviesId")
                        .HasColumnType("int");

                    b.HasKey("CharactersId", "MoviesId");

                    b.HasIndex("MoviesId");

                    b.ToTable("CharacterMovie");

                    b.HasData(
                        new
                        {
                            CharactersId = 1,
                            MoviesId = 4
                        },
                        new
                        {
                            CharactersId = 1,
                            MoviesId = 6
                        },
                        new
                        {
                            CharactersId = 2,
                            MoviesId = 1
                        },
                        new
                        {
                            CharactersId = 2,
                            MoviesId = 2
                        },
                        new
                        {
                            CharactersId = 2,
                            MoviesId = 3
                        },
                        new
                        {
                            CharactersId = 3,
                            MoviesId = 7
                        },
                        new
                        {
                            CharactersId = 3,
                            MoviesId = 8
                        },
                        new
                        {
                            CharactersId = 3,
                            MoviesId = 9
                        });
                });

            modelBuilder.Entity("MovieAPI.Models.Character", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"), 1L, 1);

                    b.Property<string>("Alias")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("FullName")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("Gender")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("PictureURL")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("nvarchar(250)");

                    b.HasKey("Id");

                    b.ToTable("Character");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Alias = "Iron Man",
                            FullName = "Tony Stark",
                            Gender = "Male",
                            PictureURL = "http://"
                        },
                        new
                        {
                            Id = 2,
                            Alias = "Frodo",
                            FullName = "Frodo Baggins",
                            Gender = "Male",
                            PictureURL = "http://"
                        },
                        new
                        {
                            Id = 3,
                            Alias = "Darth Vader",
                            FullName = "Anakin Skywalker",
                            Gender = "Male",
                            PictureURL = "http://"
                        });
                });

            modelBuilder.Entity("MovieAPI.Models.Franchise", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"), 1L, 1);

                    b.Property<string>("Description")
                        .HasMaxLength(250)
                        .HasColumnType("nvarchar(250)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.HasKey("Id");

                    b.ToTable("Franchise");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Name = "Marvel's Cinematic Universe"
                        },
                        new
                        {
                            Id = 2,
                            Name = "Lord of the Rings"
                        },
                        new
                        {
                            Id = 3,
                            Name = "Star Wars"
                        });
                });

            modelBuilder.Entity("MovieAPI.Models.Movie", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"), 1L, 1);

                    b.Property<string>("Director")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<int>("FranchiseId")
                        .HasColumnType("int");

                    b.Property<string>("Genre")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("MovieTitle")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("PictureUrl")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("nvarchar(250)");

                    b.Property<int>("ReleaseYear")
                        .HasColumnType("int");

                    b.Property<string>("TrailerUrl")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("nvarchar(250)");

                    b.HasKey("Id");

                    b.HasIndex("FranchiseId");

                    b.ToTable("Movie");

                    b.HasData(
                        new
                        {
                            Id = 4,
                            Director = "Jon Favreau",
                            FranchiseId = 1,
                            Genre = "Action",
                            MovieTitle = "Iron Man",
                            PictureUrl = "http://",
                            ReleaseYear = 2008,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 5,
                            Director = "Kenneth Branagh",
                            FranchiseId = 1,
                            Genre = "Action",
                            MovieTitle = "Thor",
                            PictureUrl = "http://",
                            ReleaseYear = 2011,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 6,
                            Director = "Joss Whedon",
                            FranchiseId = 1,
                            Genre = "Action",
                            MovieTitle = "Avengers: Age of Ultron",
                            PictureUrl = "http://",
                            ReleaseYear = 2015,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 1,
                            Director = "Peter Jackson",
                            FranchiseId = 2,
                            Genre = "high fantasy",
                            MovieTitle = "LOTR: The Fellowship of the Ring",
                            PictureUrl = "http://",
                            ReleaseYear = 2001,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 2,
                            Director = "Peter Jackson",
                            FranchiseId = 2,
                            Genre = "high fantasy",
                            MovieTitle = "LOTR: The Two Towers",
                            PictureUrl = "http://",
                            ReleaseYear = 2002,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 3,
                            Director = "Peter Jackson",
                            FranchiseId = 2,
                            Genre = "high fantasy",
                            MovieTitle = "The Return of the King",
                            PictureUrl = "http://",
                            ReleaseYear = 2003,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 7,
                            Director = "George Lucas",
                            FranchiseId = 3,
                            Genre = "Science Fiction",
                            MovieTitle = "Episode IV – A New Hope",
                            PictureUrl = "http://",
                            ReleaseYear = 1977,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 8,
                            Director = "George Lucas",
                            FranchiseId = 3,
                            Genre = "Science Fiction",
                            MovieTitle = "Episode V – The Empire Strikes Back",
                            PictureUrl = "http://",
                            ReleaseYear = 1980,
                            TrailerUrl = "http://"
                        },
                        new
                        {
                            Id = 9,
                            Director = "George Lucas",
                            FranchiseId = 3,
                            Genre = "Science Fiction",
                            MovieTitle = "Episode VI – Return of the Jedi",
                            PictureUrl = "http://",
                            ReleaseYear = 1983,
                            TrailerUrl = "http://"
                        });
                });

            modelBuilder.Entity("CharacterMovie", b =>
                {
                    b.HasOne("MovieAPI.Models.Character", null)
                        .WithMany()
                        .HasForeignKey("CharactersId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("MovieAPI.Models.Movie", null)
                        .WithMany()
                        .HasForeignKey("MoviesId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("MovieAPI.Models.Movie", b =>
                {
                    b.HasOne("MovieAPI.Models.Franchise", "Franchise")
                        .WithMany("Movies")
                        .HasForeignKey("FranchiseId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Franchise");
                });

            modelBuilder.Entity("MovieAPI.Models.Franchise", b =>
                {
                    b.Navigation("Movies");
                });
#pragma warning restore 612, 618
        }
    }
}
